// unitest.cpp : Defines the entry point for the console application.
//

#ifdef WIN32
#include <Windows.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "mxirig.h"
//#include "../mxirig/mxirig.h"

#ifdef WIN32
#ifdef _DEBUG
#pragma comment(lib, "..\\Debug\\mxirig.lib")
#else
#pragma comment(lib, "..\\Release\\mxirig.lib")
#endif
#endif

int main(int argc, char* argv[])
{
	char ch;
	char strbuff[260];
	BOOL quit = FALSE;
	DWORD dwValue, dwValue1, dwValue2;
	BOOL bValue;
	RTCTIME rtctime;
#ifdef WIN32
	SYSTEMTIME systime;
#else
	time_t rawtime;
	struct tm *systime;
#endif
	HANDLE hDev = mxIrigbOpen(0);
	printf( "mxIrigbOpen=%x\r\n", hDev);


	while(!quit)
	{
        printf("0) exit\r\n");
        printf("1) get hardware id\r\n");
		printf("2) get time  "); printf("3) set time  "); printf("4) sync system time to IRIG-B rtc\r\n");
        printf("5) set sync time source  "); printf("6) get sync time source\r\n");
        printf("7) get signal status\r\n");
        printf("8) set pps  "); printf("9) get pps\r\n");
		printf("a) set input signal  "); printf("b) get input signal\r\n");
		printf("c) set output signal  "); printf("d) get output signal\r\n");
		printf("e) set DO  "); printf("f) get DO\r\n");
		printf("g) get DI\r\n");
        printf("h) get irigb input parity check mode\r\n"); printf("i) set irigb input parity check mode\r\n");
        printf("j) get irigb output parity check mode\r\n"); printf("k) set irigb output parity check mode\r\n");

        ch = getchar();
        getchar();
		switch(ch)
		{
		case '0': quit = TRUE; break;
		case '1':
			if (mxIrigbGetHardwareID(hDev, &dwValue))
				printf("Hardware ID = %d\r\n", dwValue);
			else
				printf("Get Hardware ID error: %d\r\n", GetLastError());
			break;
		case '2':
			if (mxIrigbGetTime(hDev, &rtctime))
			{
				printf("%04d/%02d/%02d %02d:%02d:%02d.%09d\r\n",
					rtctime.year, rtctime.mon, rtctime.mday,
					rtctime.hour, rtctime.min, rtctime.sec,
					rtctime.nanosec);
				printf("LSP:%d, LS:%d, DSP:%d, DST:%d, TQ=%d\r\n",
					rtctime.lsp, rtctime.ls, rtctime.dsp, rtctime.dst,
					rtctime.tq);
				printf("TimeZone: ");
				if (rtctime.tzs) printf("-");
				printf("%d", rtctime.tz);
				if (rtctime.tzh) printf(".5");
				printf("\r\n");
			}
			else
				printf("get rtc time error: %d\r\n", GetLastError());
			break;
		case '3':
			printf("Year:   "); gets(strbuff); rtctime.year = atoi(strbuff);
			printf("Month:  "); gets(strbuff); rtctime.mon = atoi(strbuff);
			printf("Day:    "); gets(strbuff); rtctime.mday = atoi(strbuff);
			printf("Hour:   "); gets(strbuff); rtctime.hour = atoi(strbuff);
			printf("Minute: "); gets(strbuff); rtctime.min = atoi(strbuff);
			printf("Second: "); gets(strbuff); rtctime.sec = atoi(strbuff);
			if (!mxIrigbSetTime(hDev, &rtctime))
				printf("set rtc time error: %d\r\n", GetLastError());
			break;
		case '4':
#ifdef WIN32
			GetSystemTime(&systime);
			if (systime.wMilliseconds!=0)
				Sleep(1000-systime.wMilliseconds);
			GetSystemTime(&systime);
			rtctime.year = systime.wYear;
			rtctime.mon = systime.wMonth;
			rtctime.mday = systime.wDay;
			rtctime.hour = systime.wHour;
			rtctime.min = systime.wMinute;
			rtctime.sec = systime.wSecond;
#else
			struct timespec spec;
			long ms;

			clock_gettime(CLOCK_REALTIME, &spec);
			ms = spec.tv_nsec / 1000000; // Milliseconds
			if ( ms > 0 )
				usleep(1000 - ms);

			time (&rawtime);
			systime = localtime (&rawtime);

			printf ("Current local time and date: %s", asctime(systime));
		
			rtctime.year = systime->tm_year + 1900;
			rtctime.mon  = systime->tm_mon + 1;
			rtctime.mday = systime->tm_mday;
			rtctime.hour = systime->tm_hour;
			rtctime.min  = systime->tm_min;
			rtctime.sec  = systime->tm_sec;
#endif
			if (!mxIrigbSetTime(hDev, &rtctime))
				printf("sync rtc time error: %d\r\n", GetLastError());
			break;
		case '5':
			printf("Time Source(0:FREERUN 1:IRIG0 2:IRIG1): "); gets(strbuff); 
			if (!mxIrigbSetSyncTimeSrc(hDev, atoi(strbuff)))
				printf("set sync source error: %d\r\n", GetLastError());
			break;
		case '6':
			if (mxIrigbGetSyncTimeSrc(hDev, &dwValue))
				printf("Sync Time Source: %d\r\n", dwValue);
			else
				printf("get sync source error: %d\r\n", GetLastError());
			break;
		case '7':
			if (mxIrigbGetSignalStatus(hDev, TIMESRC_FIBER, &dwValue))
				printf("Source Fiber: 0x%x\r\n", dwValue);
			else
				printf("get signal status error: %d\r\n", GetLastError());
			if (mxIrigbGetSignalStatus(hDev, TIMESRC_PORT1, &dwValue))
				printf("Source Port1: 0x%x\r\n", dwValue);
			else
				printf("get signal status error: %d\r\n", GetLastError());
			break;
		case '8':
			printf("PPS width(ms): ");  gets(strbuff);
			if (!mxIrigbSetPpsWidth(hDev, atoi(strbuff)))
				printf("set PPS width error: %d\r\n", GetLastError());
			break;
		case '9':
			if (mxIrigbGetPpsWidth(hDev, &dwValue))
				printf("PPS width = %d ms\r\n", dwValue);
			else
				printf("get PPS width error: %d\r\n", GetLastError());
			break;
		case 'a':
			printf("Port(0:FIBER 1:PORT1): "); gets(strbuff); dwValue = atoi(strbuff);
			printf("Type(0: TTL, 1:DIFF): "); gets(strbuff); dwValue1 = atoi(strbuff);
			printf("Invert(0: Normal, 1:Invert): "); gets(strbuff); bValue = atoi(strbuff);
			if (!mxIrigbSetInputSignalType(hDev, dwValue, dwValue1, bValue))
				printf("mxIrigbSetInputSignalType error: %d\r\n", GetLastError());
			break;
		case 'b':
			printf("PORT_FIBER:");
			if (mxIrigbGetInputSignalType(hDev, PORT_FIBER, &dwValue1, &bValue))
			{
				if (dwValue1==0) printf("TTL");
				else printf("DIFFERENTIAL");
				if (bValue)
					printf(", Invert");
				printf("\r\n");
			}
			else
				printf("mxIrigbGetInputsignal error: %d\r\n", GetLastError());
			printf("PORT_1:");
			if (mxIrigbGetInputSignalType(hDev, PORT_1, &dwValue1, &bValue))
			{
				if (dwValue1==0) printf("TTL");
				else printf("DIFFERENTIAL");
				if (bValue)
					printf(", Invert");
				printf("\r\n");
			}
			else
				printf("mxIrigbGetInputSignalType error: %d\r\n", GetLastError());
			break;
		case 'c':
			printf("Port(1:PORT1, 2:PORT2, 3:PORT3, 4:PORT4): "); gets(strbuff); dwValue = atoi(strbuff);
			printf("Type(0: TTL, 1:DIFF): "); gets(strbuff); dwValue1 = atoi(strbuff);
			printf("Mode(0: From Fiber, 1:From Port 1, 2:IRIG, 3:PPS): "); gets(strbuff); dwValue2 = atoi(strbuff);
			printf("Invert(0: Normal, 1:Invert): "); gets(strbuff); bValue = atoi(strbuff);
			if (!mxIrigbSetOutputSignalType(hDev, dwValue, dwValue1, dwValue2, bValue))
				printf("mxIrigbSetOutputSignalType error: %d\r\n", GetLastError());
			break;
		case 'd':
			for (int i=1;i<=4;i++)
			{
				printf("PORT_%d:", i);
				if (mxIrigbGetOutputSignalType(hDev, i, &dwValue1, &dwValue2, &bValue))
				{
					if (dwValue1==0) printf("TTL");
					else printf("DIFFERENTIAL");
					printf(",");
					if (dwValue2==0) printf("From Fiber");
					else
					if (dwValue2==1) printf("From Port1");
					else
					if (dwValue2==2) printf("IRIGB");
					else
					if (dwValue2==3) printf("PPS");
					else printf("UNKNOWN");

					if (bValue)
						printf(", Invert");
					printf("\r\n");
				}
				else
					printf("mxIrigbGetOutputSignalType error: %d\r\n", GetLastError());
			}
			break;
		case 'e':
			printf("Set DO port: ");  gets(strbuff); dwValue = atoi(strbuff);
			printf("Set DO value: ");  gets(strbuff); dwValue1 = atoi(strbuff);
			if (!mxIrigbSetDigitalOutputSignal(hDev, dwValue, dwValue1))
			{
				printf("mxIrigbSetDigitalOutputSignal error: %d\r\n", GetLastError());
			}
			break;
		case 'f':
			for ( int i=0;i<4;i++)
			{
				if (!mxIrigbGetDigitalOutputSignal(hDev, i, &dwValue1))
				{
					printf("DO %d = %d\r\n", i, dwValue1);
				}
				else
				{
					printf("mxIrigbGetDigitalOutputSignal error: %d\r\n", GetLastError());
				}
			}
			break;
		case 'g':
			for ( int i=0;i<4;i++)
			{
				if (!mxIrigbGetDigitalInputSignal(hDev, i, &dwValue1))
				{
					printf("DI %d = %d\r\n", i, dwValue1);
				}
				else
				{
					printf("mxIrigbGetDigitalInputSignal error: %d\r\n", GetLastError());
				}
			}
			break;

        case 'h':
			printf("IRIGB Source (1:FIBER in 2:PORT1 in): "); gets(strbuff); dwValue = atoi(strbuff);
			if (mxIrigbGetInputParityCheckMode(hDev, dwValue, &dwValue1))
			{
				printf("Parity Check Mode is ");
                if ( dwValue1 == PARITY_CHECK_EVEN )
                    printf("EVEN");
                else if ( dwValue1 == PARITY_CHECK_ODD )
                    printf("ODD");
                else if ( dwValue1 == PARITY_CHECK_NONE )
                    printf("NONE");
                else
                    printf("UNKNOWN");
                printf("\r\n");
			}
			else
			{
				printf("mxIrigbGetInputParityCheckMode error: %d\r\n", GetLastError());
			}
            break;

        case 'i':
			printf("IRIGB Source (1:FIBER in 2:PORT1 in): "); gets(strbuff); dwValue = atoi(strbuff);
            printf("Parity Check (0:EVEN 1:ODD 2:NONE): "); gets(strbuff); dwValue1 = atoi(strbuff);
			if (!mxIrigbSetInputParityCheckMode(hDev, dwValue, dwValue1))
			{
				printf("mxIrigbSetInputParityCheckMode error: %d\r\n", GetLastError());
			}
            break;

        case 'j':
			if (mxIrigbGetOutputParityCheckMode(hDev, &dwValue))
			{
				printf("Parity Check Mode is ");
                if ( dwValue == PARITY_CHECK_EVEN )
                    printf("EVEN");
                else if ( dwValue == PARITY_CHECK_ODD )
                    printf("ODD");
                else if ( dwValue == PARITY_CHECK_NONE )
                    printf("NONE");
                else
                    printf("UNKNOWN");
                printf("\r\n");
			}
			else
			{
				printf("mxIrigbGetOutputParityCheckMode error: %d\r\n", GetLastError());
			}
            break;

        case 'k':
            printf("Parity Check (0:EVEN 1:ODD 2:NONE): "); gets(strbuff); dwValue = atoi(strbuff);
			if (!mxIrigbSetOutputParityCheckMode(hDev, dwValue))
			{
				printf("mxIrigbSetOutputParityCheckMode error: %d\r\n", GetLastError());
			}
            break;
		}
	}

	mxIrigbClose(hDev);
	return 0;
}

